=== Base/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainSim
############################################################################

set(component Base)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

#--- define target properties ---
add_library(${lib} SHARED)
set_target_properties(${lib} PROPERTIES
    COMPONENT_NAME ${component}
    SWIG_TMP_DIR "${CMAKE_CURRENT_BINARY_DIR}/Wrap"
    SOURCE_FILES "${source_files}"
    INCLUDE_FILES "${include_files}"
    EMBED_PYTHON ${BORNAGAIN_PYTHON})

# --- make the library ---
MakeLib(${lib})

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    ${GSL_LIBRARIES}
    ${FFTW3_LIBRARIES}
)

target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    SYSTEM PUBLIC
    ${LibHeinz_INCLUDE_DIR}
    ${Boost_INCLUDE_DIRS}
    # the following needed for Mac and Win, even if they are implied under Linux
    ${GSL_INCLUDE_DIR}
    ${FFTW3_INCLUDE_DIR}
)

# g++ versions less than 9.1 need to link against libstdc++fs
# if std::filesystem is used
if(GCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.1)
    target_link_libraries(${lib} PRIVATE stdc++fs)
endif()
# the same applies to clang versions less than 9.0: they need to link
# against libstdc++fs or libc++fs if std::filesystem is used
if(CLANG AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 9.0)
    if(LINUX)
        target_link_libraries(${lib} PRIVATE stdc++fs)
    else()
        target_link_libraries(${lib} PRIVATE c++fs)
    endif()
endif()

if(WIN32)
    target_compile_definitions(${lib} PRIVATE -DBA_BASE_BUILD_DLL)
endif()
