=== Device/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainDevice
############################################################################

set(component Device)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- define target properties ---
add_library(${lib} SHARED)
set_target_properties(${lib} PROPERTIES
    COMPONENT_NAME ${component}
    SWIG_TMP_DIR "${CMAKE_CURRENT_BINARY_DIR}/Wrap"
    SOURCE_FILES "${source_files}"
    INCLUDE_FILES "${include_files}"
    EMBED_PYTHON ${BORNAGAIN_PYTHON})

# --- make the library ---
MakeLib(${lib})

# --- external dependencies ---

target_link_libraries(${lib}
    PUBLIC
    BornAgainBase
    BornAgainFit
    BornAgainParam
    BornAgainSample
    BornAgainResample
    ${CMAKE_THREAD_LIBS_INIT}
    ${tspectrum_LIBRARY}
)
if(BORNAGAIN_PYTHON)
    target_link_libraries(${lib} PUBLIC BornAgainPyCore)
endif()

target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    SYSTEM PUBLIC
    ${tspectrum_INCLUDE_DIR}
    )

if(BA_TIFF_SUPPORT)
    target_link_libraries(${lib} PUBLIC ${TIFF_LIBRARIES})
    target_include_directories(${lib} PUBLIC ${TIFF_INCLUDE_DIR})
    target_compile_definitions(${lib} PUBLIC -DBA_TIFF_SUPPORT)
endif()

if(WIN32)
    target_compile_definitions(${lib} PRIVATE -DBA_DEVICE_BUILD_DLL)
endif()
