=== PyCore/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainPyCore
############################################################################

# NOTE: The module is directly dependent on Python and Numpy C-API
if(NOT BORNAGAIN_PYTHON)
    return()
endif()

set(component PyCore)
set(lib BornAgain${component})

# --- source and include files ---
# Python-dependent source files
file(GLOB_RECURSE source_files */*.cpp)
file(GLOB_RECURSE include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- define target properties ---
add_library(${lib} SHARED)
set_target_properties(${lib} PROPERTIES
    COMPONENT_NAME ${component}
    SWIG_TMP_DIR ""
    SOURCE_FILES "${source_files}"
    INCLUDE_FILES "${include_files}"
    EMBED_PYTHON ${BORNAGAIN_PYTHON})

# --- make the library ---
MakeLib(${lib})

target_include_directories(${lib}
    PRIVATE
    ${CMAKE_SOURCE_DIR}
    ${LibHeinz_INCLUDE_DIR}
    ${Python3_INCLUDE_DIRS}
    ${Python3_NumPy_INCLUDE_DIRS}
)

target_link_libraries(${lib}
    PUBLIC
    ${Python3_LIBRARIES}
)
