=== Resample/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainResample
############################################################################

set(component Resample)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- define target properties ---
add_library(${lib} SHARED)
set_target_properties(${lib} PROPERTIES
    COMPONENT_NAME ${component}
    SWIG_TMP_DIR "${CMAKE_CURRENT_BINARY_DIR}/Wrap"
    SOURCE_FILES "${source_files}"
    INCLUDE_FILES "${include_files}"
    EMBED_PYTHON ${BORNAGAIN_PYTHON})

# --- make the library ---
MakeLib(${lib})

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    BornAgainSample
    )
target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    )
