=== Sim/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building libBornAgainSim
############################################################################

set(component Sim)
set(lib BornAgain${component})

# --- source and include files ---

file(GLOB source_files */*.cpp)
file(GLOB include_files RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} */*.h)

# --- define target properties ---
add_library(${lib} SHARED)
set_target_properties(${lib} PROPERTIES
    COMPONENT_NAME ${component}
    SWIG_TMP_DIR "${CMAKE_CURRENT_BINARY_DIR}/Wrap"
    SOURCE_FILES "${source_files}"
    INCLUDE_FILES "${include_files}"
    EMBED_PYTHON ${BORNAGAIN_PYTHON})
if(BATCH_MODE)
    target_compile_definitions(${lib} PRIVATE SILENT_PROGRESS=ON)
endif()

# --- make the library ---
MakeLib(${lib})

# --- external dependences ---

target_link_libraries(${lib}
    PUBLIC
    BornAgainSample
    BornAgainDevice
    PRIVATE
    BornAgainResample
    ${CMAKE_THREAD_LIBS_INIT}
    ${cerf_target})

target_include_directories(${lib}
    PUBLIC
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/3rdparty/Core/ # needed for cerfcpp header
    )
