=== debian/changelog ===
bornagain (21.1+ds3-4) unstable; urgency=medium

  * Bug fix: "Please drop dependencies on python3-distutils", thanks to
    Graham Inggs (Closes: #1065835).

 -- Roland Mas <lolando@debian.org>  Thu, 21 Mar 2024 22:38:28 +0100

bornagain (21.1+ds3-3) unstable; urgency=medium

  * Link against Swig 4.2; this fixes: "FTBFS: make[1]: ***
    [debian/rules:41: override_dh_auto_configure] Error 2", thanks to
    Lucas Nussbaum (Closes: #1064750).
  * For some reason, this also fixes: "ftbfs with LTO (link time
    optimization) enabled", thanks to Matthias Klose (Closes: #1015364).

 -- Roland Mas <lolando@debian.org>  Wed, 28 Feb 2024 18:29:19 +0100

bornagain (21.1+ds3-2) unstable; urgency=medium

  * d/rules: fix FTBFS on arch all
  * d/rules: use the current cmake options
  * split the arch/indep install target

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Thu, 14 Dec 2023 16:58:21 +0100

bornagain (21.1+ds3-1) unstable; urgency=medium

  * d/control: Added B-D libcerf-dev (>= 2.3)
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * Rules-Requires-Root: no (routine-update)

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Wed, 13 Dec 2023 09:23:08 +0100
