=== debian/tests/control ===
# tests that must pass

Tests: python3
Depends:
 python3-all,
 python3-bornagain,
Restrictions: allow-stderr, skip-not-installable
