=== debian/watch ===
version=4
opts=\
dversionmangle=auto,\
repacksuffix=+ds3,\
repack,\
filenamemangle=s/.*?(\d[\d\.]*@ARCHIVE_EXT@)/@PACKAGE@-$1/ \
https://jugit.fz-juelich.de/mlz/bornagain/tags?sort=updated_desc .*/v?@ANY_VERSION@/.*@ARCHIVE_EXT@
